/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1619
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set OUT9 aliases
#define OUT9_TRIS                 TRISAbits.TRISA0
#define OUT9_LAT                  LATAbits.LATA0
#define OUT9_PORT                 PORTAbits.RA0
#define OUT9_WPU                  WPUAbits.WPUA0
#define OUT9_OD                   ODCONAbits.ODA0
#define OUT9_ANS                  ANSELAbits.ANSA0
#define OUT9_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define OUT9_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define OUT9_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define OUT9_GetValue()           PORTAbits.RA0
#define OUT9_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define OUT9_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define OUT9_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define OUT9_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define OUT9_SetPushPull()        do { ODCONAbits.ODA0 = 0; } while(0)
#define OUT9_SetOpenDrain()       do { ODCONAbits.ODA0 = 1; } while(0)
#define OUT9_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define OUT9_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set RA1 procedures
#define RA1_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define RA1_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define RA1_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define RA1_GetValue()              PORTAbits.RA1
#define RA1_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define RA1_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define RA1_SetPullup()             do { WPUAbits.WPUA1 = 1; } while(0)
#define RA1_ResetPullup()           do { WPUAbits.WPUA1 = 0; } while(0)
#define RA1_SetAnalogMode()         do { ANSELAbits.ANSA1 = 1; } while(0)
#define RA1_SetDigitalMode()        do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set IN10 aliases
#define IN10_TRIS                 TRISAbits.TRISA2
#define IN10_LAT                  LATAbits.LATA2
#define IN10_PORT                 PORTAbits.RA2
#define IN10_WPU                  WPUAbits.WPUA2
#define IN10_OD                   ODCONAbits.ODA2
#define IN10_ANS                  ANSELAbits.ANSA2
#define IN10_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define IN10_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define IN10_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define IN10_GetValue()           PORTAbits.RA2
#define IN10_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define IN10_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define IN10_SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define IN10_ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define IN10_SetPushPull()        do { ODCONAbits.ODA2 = 0; } while(0)
#define IN10_SetOpenDrain()       do { ODCONAbits.ODA2 = 1; } while(0)
#define IN10_SetAnalogMode()      do { ANSELAbits.ANSA2 = 1; } while(0)
#define IN10_SetDigitalMode()     do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set RB4 procedures
#define RB4_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define RB4_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define RB4_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define RB4_GetValue()              PORTBbits.RB4
#define RB4_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define RB4_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define RB4_SetPullup()             do { WPUBbits.WPUB4 = 1; } while(0)
#define RB4_ResetPullup()           do { WPUBbits.WPUB4 = 0; } while(0)
#define RB4_SetAnalogMode()         do { ANSELBbits.ANSB4 = 1; } while(0)
#define RB4_SetDigitalMode()        do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set TX_EN aliases
#define TX_EN_TRIS                 TRISBbits.TRISB5
#define TX_EN_LAT                  LATBbits.LATB5
#define TX_EN_PORT                 PORTBbits.RB5
#define TX_EN_WPU                  WPUBbits.WPUB5
#define TX_EN_OD                   ODCONBbits.ODB5
#define TX_EN_ANS                  ANSELBbits.ANSB5
#define TX_EN_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define TX_EN_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define TX_EN_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define TX_EN_GetValue()           PORTBbits.RB5
#define TX_EN_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define TX_EN_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define TX_EN_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define TX_EN_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define TX_EN_SetPushPull()        do { ODCONBbits.ODB5 = 0; } while(0)
#define TX_EN_SetOpenDrain()       do { ODCONBbits.ODB5 = 1; } while(0)
#define TX_EN_SetAnalogMode()      do { ANSELBbits.ANSB5 = 1; } while(0)
#define TX_EN_SetDigitalMode()     do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set RB6 procedures
#define RB6_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define RB6_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define RB6_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define RB6_GetValue()              PORTBbits.RB6
#define RB6_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define RB6_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define RB6_SetPullup()             do { WPUBbits.WPUB6 = 1; } while(0)
#define RB6_ResetPullup()           do { WPUBbits.WPUB6 = 0; } while(0)
#define RB6_SetAnalogMode()         do { ANSELBbits.ANSB6 = 1; } while(0)
#define RB6_SetDigitalMode()        do { ANSELBbits.ANSB6 = 0; } while(0)

// get/set IN9 aliases
#define IN9_TRIS                 TRISBbits.TRISB7
#define IN9_LAT                  LATBbits.LATB7
#define IN9_PORT                 PORTBbits.RB7
#define IN9_WPU                  WPUBbits.WPUB7
#define IN9_OD                   ODCONBbits.ODB7
#define IN9_ANS                  ANSELBbits.ANSB7
#define IN9_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define IN9_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define IN9_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define IN9_GetValue()           PORTBbits.RB7
#define IN9_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define IN9_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)
#define IN9_SetPullup()          do { WPUBbits.WPUB7 = 1; } while(0)
#define IN9_ResetPullup()        do { WPUBbits.WPUB7 = 0; } while(0)
#define IN9_SetPushPull()        do { ODCONBbits.ODB7 = 0; } while(0)
#define IN9_SetOpenDrain()       do { ODCONBbits.ODB7 = 1; } while(0)
#define IN9_SetAnalogMode()      do { ANSELBbits.ANSB7 = 1; } while(0)
#define IN9_SetDigitalMode()     do { ANSELBbits.ANSB7 = 0; } while(0)

// get/set Q7 aliases
#define Q7_TRIS                 TRISCbits.TRISC0
#define Q7_LAT                  LATCbits.LATC0
#define Q7_PORT                 PORTCbits.RC0
#define Q7_WPU                  WPUCbits.WPUC0
#define Q7_OD                   ODCONCbits.ODC0
#define Q7_ANS                  ANSELCbits.ANSC0
#define Q7_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define Q7_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define Q7_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define Q7_GetValue()           PORTCbits.RC0
#define Q7_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define Q7_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define Q7_SetPullup()          do { WPUCbits.WPUC0 = 1; } while(0)
#define Q7_ResetPullup()        do { WPUCbits.WPUC0 = 0; } while(0)
#define Q7_SetPushPull()        do { ODCONCbits.ODC0 = 0; } while(0)
#define Q7_SetOpenDrain()       do { ODCONCbits.ODC0 = 1; } while(0)
#define Q7_SetAnalogMode()      do { ANSELCbits.ANSC0 = 1; } while(0)
#define Q7_SetDigitalMode()     do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set ADC1 aliases
#define ADC1_TRIS                 TRISCbits.TRISC1
#define ADC1_LAT                  LATCbits.LATC1
#define ADC1_PORT                 PORTCbits.RC1
#define ADC1_WPU                  WPUCbits.WPUC1
#define ADC1_OD                   ODCONCbits.ODC1
#define ADC1_ANS                  ANSELCbits.ANSC1
#define ADC1_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define ADC1_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define ADC1_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define ADC1_GetValue()           PORTCbits.RC1
#define ADC1_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define ADC1_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define ADC1_SetPullup()          do { WPUCbits.WPUC1 = 1; } while(0)
#define ADC1_ResetPullup()        do { WPUCbits.WPUC1 = 0; } while(0)
#define ADC1_SetPushPull()        do { ODCONCbits.ODC1 = 0; } while(0)
#define ADC1_SetOpenDrain()       do { ODCONCbits.ODC1 = 1; } while(0)
#define ADC1_SetAnalogMode()      do { ANSELCbits.ANSC1 = 1; } while(0)
#define ADC1_SetDigitalMode()     do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set ADC2 aliases
#define ADC2_TRIS                 TRISCbits.TRISC2
#define ADC2_LAT                  LATCbits.LATC2
#define ADC2_PORT                 PORTCbits.RC2
#define ADC2_WPU                  WPUCbits.WPUC2
#define ADC2_OD                   ODCONCbits.ODC2
#define ADC2_ANS                  ANSELCbits.ANSC2
#define ADC2_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define ADC2_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define ADC2_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define ADC2_GetValue()           PORTCbits.RC2
#define ADC2_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define ADC2_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define ADC2_SetPullup()          do { WPUCbits.WPUC2 = 1; } while(0)
#define ADC2_ResetPullup()        do { WPUCbits.WPUC2 = 0; } while(0)
#define ADC2_SetPushPull()        do { ODCONCbits.ODC2 = 0; } while(0)
#define ADC2_SetOpenDrain()       do { ODCONCbits.ODC2 = 1; } while(0)
#define ADC2_SetAnalogMode()      do { ANSELCbits.ANSC2 = 1; } while(0)
#define ADC2_SetDigitalMode()     do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set DATA_OUT aliases
#define DATA_OUT_TRIS                 TRISCbits.TRISC3
#define DATA_OUT_LAT                  LATCbits.LATC3
#define DATA_OUT_PORT                 PORTCbits.RC3
#define DATA_OUT_WPU                  WPUCbits.WPUC3
#define DATA_OUT_OD                   ODCONCbits.ODC3
#define DATA_OUT_ANS                  ANSELCbits.ANSC3
#define DATA_OUT_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define DATA_OUT_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define DATA_OUT_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define DATA_OUT_GetValue()           PORTCbits.RC3
#define DATA_OUT_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define DATA_OUT_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define DATA_OUT_SetPullup()          do { WPUCbits.WPUC3 = 1; } while(0)
#define DATA_OUT_ResetPullup()        do { WPUCbits.WPUC3 = 0; } while(0)
#define DATA_OUT_SetPushPull()        do { ODCONCbits.ODC3 = 0; } while(0)
#define DATA_OUT_SetOpenDrain()       do { ODCONCbits.ODC3 = 1; } while(0)
#define DATA_OUT_SetAnalogMode()      do { ANSELCbits.ANSC3 = 1; } while(0)
#define DATA_OUT_SetDigitalMode()     do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set LATCH_OUT aliases
#define LATCH_OUT_TRIS                 TRISCbits.TRISC4
#define LATCH_OUT_LAT                  LATCbits.LATC4
#define LATCH_OUT_PORT                 PORTCbits.RC4
#define LATCH_OUT_WPU                  WPUCbits.WPUC4
#define LATCH_OUT_OD                   ODCONCbits.ODC4
#define LATCH_OUT_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define LATCH_OUT_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define LATCH_OUT_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define LATCH_OUT_GetValue()           PORTCbits.RC4
#define LATCH_OUT_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define LATCH_OUT_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define LATCH_OUT_SetPullup()          do { WPUCbits.WPUC4 = 1; } while(0)
#define LATCH_OUT_ResetPullup()        do { WPUCbits.WPUC4 = 0; } while(0)
#define LATCH_OUT_SetPushPull()        do { ODCONCbits.ODC4 = 0; } while(0)
#define LATCH_OUT_SetOpenDrain()       do { ODCONCbits.ODC4 = 1; } while(0)

// get/set CLOCK_OUT aliases
#define CLOCK_OUT_TRIS                 TRISCbits.TRISC5
#define CLOCK_OUT_LAT                  LATCbits.LATC5
#define CLOCK_OUT_PORT                 PORTCbits.RC5
#define CLOCK_OUT_WPU                  WPUCbits.WPUC5
#define CLOCK_OUT_OD                   ODCONCbits.ODC5
#define CLOCK_OUT_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define CLOCK_OUT_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define CLOCK_OUT_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define CLOCK_OUT_GetValue()           PORTCbits.RC5
#define CLOCK_OUT_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define CLOCK_OUT_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define CLOCK_OUT_SetPullup()          do { WPUCbits.WPUC5 = 1; } while(0)
#define CLOCK_OUT_ResetPullup()        do { WPUCbits.WPUC5 = 0; } while(0)
#define CLOCK_OUT_SetPushPull()        do { ODCONCbits.ODC5 = 0; } while(0)
#define CLOCK_OUT_SetOpenDrain()       do { ODCONCbits.ODC5 = 1; } while(0)

// get/set PL aliases
#define PL_TRIS                 TRISCbits.TRISC6
#define PL_LAT                  LATCbits.LATC6
#define PL_PORT                 PORTCbits.RC6
#define PL_WPU                  WPUCbits.WPUC6
#define PL_OD                   ODCONCbits.ODC6
#define PL_ANS                  ANSELCbits.ANSC6
#define PL_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define PL_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define PL_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define PL_GetValue()           PORTCbits.RC6
#define PL_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define PL_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define PL_SetPullup()          do { WPUCbits.WPUC6 = 1; } while(0)
#define PL_ResetPullup()        do { WPUCbits.WPUC6 = 0; } while(0)
#define PL_SetPushPull()        do { ODCONCbits.ODC6 = 0; } while(0)
#define PL_SetOpenDrain()       do { ODCONCbits.ODC6 = 1; } while(0)
#define PL_SetAnalogMode()      do { ANSELCbits.ANSC6 = 1; } while(0)
#define PL_SetDigitalMode()     do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set CP aliases
#define CP_TRIS                 TRISCbits.TRISC7
#define CP_LAT                  LATCbits.LATC7
#define CP_PORT                 PORTCbits.RC7
#define CP_WPU                  WPUCbits.WPUC7
#define CP_OD                   ODCONCbits.ODC7
#define CP_ANS                  ANSELCbits.ANSC7
#define CP_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define CP_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define CP_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define CP_GetValue()           PORTCbits.RC7
#define CP_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define CP_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define CP_SetPullup()          do { WPUCbits.WPUC7 = 1; } while(0)
#define CP_ResetPullup()        do { WPUCbits.WPUC7 = 0; } while(0)
#define CP_SetPushPull()        do { ODCONCbits.ODC7 = 0; } while(0)
#define CP_SetOpenDrain()       do { ODCONCbits.ODC7 = 1; } while(0)
#define CP_SetAnalogMode()      do { ANSELCbits.ANSC7 = 1; } while(0)
#define CP_SetDigitalMode()     do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/