/* 
 * File:   
 * Author: 
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef HC595_H
#define	HC595_H

#include <xc.h> // include processor files - each processor file is guarded.  

// Define the pins used
#define HC595_SER           PORTCbits.RC3 
#define HC595_RCLK          PORTCbits.RC4 
#define HC595_SRCLK         PORTCbits.RC5 
#define HC595_SER_TRIS      TRISCbits.TRISC3
#define HC595_RCLK_TRIS     TRISCbits.TRISC4
#define HC595_SRCLK_TRIS    TRISCbits.TRISC5

/****** DO NOT CHANGE VALUES BELOW ******/
#define HC595_LSB_FIRST 0
#define HC595_MSB_FIRST 1
#define DELAY 1 // usec delay

/**
 * Initialize HC595 module
 */
void HC595Init();

/**
 * Clear the output.
 */
void HC595Clear();

/**
 * Send a value to the HC595.
 * @param value
 */
void HC595SendValue(uint8_t, uint8_t);

/**
 * Toggle the SRCLK pin of the HC595
 */
void HC595ToggleClk();

/**
 * Toggle the RCLK pin of the HC595 to register output
 */
void HC595TriggerOutput();



#endif	/* 74HC595_H */

