/* 
 * File:   
 * Author: 
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef PLC_SIRIUS_H
#define	PLC_SIRIUS_H


/*
 0-15 Digital Outs
 16-31 Digital Inputs
 32-47 Analog Inputs
 
 */

#define PLC_V1

#ifdef PLC_V1

#define HC165_PL PORTCbits.RC6 
#define HC165_CP PORTCbits.RC7 
#define HC165_Q7 PORTCbits.RC0  
#define DELAY_READ 1

#define TX_Disable()            do { LATBbits.LATB5 = 0; } while(0)
#define TX_Enable()             do { LATBbits.LATB5 = 1; } while(0)

#define OUT1 0
#define OUT2 1
#define OUT3 2
#define OUT4 3
#define OUT5 4
#define OUT6 5
#define OUT7 6
#define OUT8 7
#define OUT9 8
#define OUT10 9
#define OUT11 10

#define IN1 16
#define IN2 17
#define IN3 18
#define IN4 19
#define IN5 20
#define IN6 21
#define IN7 22
#define IN8 23
#define IN9 24
#define IN10 25
#define IN11 26
#define IN12 27

#define A1 32
#define A2 33

#define TX_EN OUT11

#endif

#include <xc.h> // include processor files - each processor file is guarded.  

volatile static uint16_t outImage;
volatile static uint16_t inImage;

void analogWrite(uint8_t, uint16_t);
uint16_t analogRead(uint8_t);
void digitalWrite(uint8_t, bool);
bool digitalRead(uint8_t);
void HC165TriggerOutput();
void HC165ToggleClk();
uint8_t HC165ReadValue(uint8_t);

//void output_init();
static uint8_t convertInputNumberToBit(uint8_t);
static uint8_t convertOutNumberToBit(uint8_t);
static void setOutImageBit(uint8_t);
static void clearOutImageBit(uint8_t);
void updateHC595();

int16_t map(int16_t, int16_t, int16_t, int16_t, int16_t);

#endif	/* PLC_SIRIUS_H */

