/* 
 * File:   millis.h
 * Author: Berran Remzi
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef MILLIS_H
#define	MILLIS_H

#include <xc.h> // include processor files - each processor file is guarded.  
#include <stdint.h>
#include <stdbool.h>

volatile uint32_t timer_millis;
volatile uint32_t previousTime[6];
volatile uint32_t currentTime = 0;

extern void call_millis();
extern uint32_t millis();
extern bool SoftTimerInterrupt(uint16_t, uint8_t);
extern bool SoftTimerInterrupt10ms();
extern bool SoftTimerInterrupt50ms();
bool SoftTimerInterrupt100ms();
extern bool SoftTimerInterrupt500ms();
extern bool SoftTimerInterrupt1s();
extern bool SoftTimerInterrupt5s();

#endif	/* MILLIS_H */

